/*____________________________________________________________________________
	
	Voyeur - a Windows Network Crawler

	by Jawed Karim, 1999. http://www.jawed.com/

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
____________________________________________________________________________*/

#include "stdafx.h"

#include "Resource.h"
#include "searchdialog.h"
#include "VoyeurView.h"

char CSearchDialog::m_findtext[1024];

IMPLEMENT_DYNCREATE (CSearchDialog, CDialog)

BEGIN_MESSAGE_MAP (CSearchDialog, CDialog)
	ON_BN_CLICKED (IDFINDNEXT, OnFindNextButton)
END_MESSAGE_MAP()

void CSearchDialog::OnOK ()
{
	GetDlgItemText (IDC_EDIT_SEARCH, m_findtext, 1024);

	CDialog::OnOK ();
}

CSearchDialog::CSearchDialog (CWnd *pParent)
: CDialog (IDD_SEARCH_LIST_DIALOG, pParent)
{
	m_pParent = pParent;
}

BOOL CSearchDialog::OnInitDialog ()
{
	CDialog::OnInitDialog ();

	SetDlgItemText (IDC_EDIT_SEARCH, m_findtext);

	return TRUE;
}

void CSearchDialog::OnFindNextButton ()
{
	CVoyeurView *pViewWindow = (CVoyeurView *)m_pParent;

	if (pViewWindow->GetNumListItems () == 0)
	{
		AfxMessageBox ("String not found.");
		return;
	}

	// get text
	GetDlgItemText (IDC_EDIT_SEARCH, m_findtext, 1024);

	// start one beyond already selected one.
	int iSelected = pViewWindow->GetSelectedItem () + 1;

	// start at the currently selected one
	int iFoundIndex;

	iFoundIndex = pViewWindow->FindItem (m_findtext, iSelected);

	if (iFoundIndex != -1)
	{
		pViewWindow->SelectItem (iFoundIndex);
		return;
	}

	// nothing was found when search started from currently selected one. start over from 0.
	iFoundIndex = pViewWindow->FindItem (m_findtext, 0);

	if (iFoundIndex != -1)
	{
		pViewWindow->SelectItem (iFoundIndex);
		return;
	}

	// still here, nothing found
	AfxMessageBox ("String not found.");
}