/*____________________________________________________________________________
	
	Voyeur - a Windows Network Crawler

	by Jawed Karim, 1999. http://www.jawed.com/

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
____________________________________________________________________________*/

#include <afxcview.h>
#include "VoyeurDoc.h"

// VoyeurView.h : interface of the CVoyeurView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VOYEURVIEW_H__C667FBAC_8D4C_11D2_B718_00608C85D7E8__INCLUDED_)
#define AFX_VOYEURVIEW_H__C667FBAC_8D4C_11D2_B718_00608C85D7E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CVoyeurView : public CListView
{
protected: // create from serialization only
	CVoyeurView();
	DECLARE_DYNCREATE (CVoyeurView)

// Attributes
public:

	int GetNumListItems ();									// returns the number of items in list
	int GetSelectedItem ();
	void SelectItem (int);
	int FindItem (char *, int);

	void DeleteAllListItems ();
	BOOL InsertFileItem (char *, char *);				// inserts items into the list view

	BOOL GetFileItemText (int, char *, char *);				// get the text back
	BOOL GetFileItemText (int, char *, char *, char *);
	BOOL ThreadRunning ();									// determines state of thread
	BOOL LaunchFile (HWND, char *);

	///////////

	CVoyeurDoc* GetDocument();

	int OnCreate (LPCREATESTRUCT);
	void OnDestroy ();
	virtual BOOL PreCreateWindow (CREATESTRUCT &);
	virtual void OnInitialUpdate ();

	///////////

	void OnExecuteFile ();
	void OnStartSearch ();
	void OnOpenFolder ();
	void OnClickHelp ();

	void OnFindInList ();
	static int CALLBACK CompareFunc (LPARAM, LPARAM, LPARAM);

	void OnItemDoubleClicked (LPNMHDR *, LRESULT *);
	void OnColumnClick (NMHDR *, LRESULT *);

	virtual ~CVoyeurView();

#ifdef _DEBUG
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
	// pointer to thread
	CWinThread *m_pSearchThread;

	// thread handle
	HANDLE m_hThreadHandle;

protected:

	CImageList m_ImageListBig;
	CImageList m_ImageListSmall;

	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in VoyeurView.cpp
inline CVoyeurDoc* CVoyeurView::GetDocument()
   { return (CVoyeurDoc*)m_pDocument; }
#endif

#endif // !defined(AFX_VOYEURVIEW_H__C667FBAC_8D4C_11D2_B718_00608C85D7E8__INCLUDED_)
