//
// LFError.h
//

#ifndef __LFERROR_H__
#define __LFERROR_H__

#include <string>
using namespace std;

#define PARSER_SUCCESS 0xFFFFFFFF

struct LdapFilterError {
    size_t m_sCode;
    wchar_t * m_szError;
};

extern LdapFilterError LFErrors[];

// LDAP Filter Error
#define LFE_NO_ATTRIBUTE_TYPE		0x1001
#define LFE_TYPE_ONLY_SPACES		0x1002
#define LFE_SPACE_MIDDLE_TYPE		0x1003
#define LFE_NO_ATTRIBUTE_VALUE		0x1004
#define LFE_VALUE_ONLY_SPACES		0x1005
#define LFE_ESC_CHAR_WITHOUT_ESCAPABLE	0x1006
#define LFE_INVALID_TOKEN		0x1007
#define LFE_BRACKET_MISMATCH		0x1008
#define LFE_NO_VALID_COMPARISON		0x1009
#define LFE_NOT_SUPPORT_SINGLE_COMP	0x100A



class CFilterException
{
public:
    CFilterException(size_t sErrorCode, size_t sPos)
	:m_sErrorCode(sErrorCode), m_sPos(sPos)
    { }

    CFilterException(const CFilterException & rhs)
	:m_sErrorCode(rhs.m_sErrorCode), m_sPos(rhs.m_sPos)
    { }

    ~CFilterException() 
    { }

    CFilterException & operator=(const CFilterException &rhs)
    {
	m_sErrorCode = rhs.m_sErrorCode;
	m_sPos = rhs.m_sPos;
    }

    const wchar_t * GetError() const { 
	int i = 0;
	while(LFErrors[i].m_sCode) {
	    if(LFErrors[i].m_sCode==m_sErrorCode)
		return LFErrors[i].m_szError;
	    i++;
	}
	return NULL;
    }
    size_t GetPos() const { return m_sPos; }

private:
    size_t m_sErrorCode;
    size_t m_sPos;
};

#endif