/******************************************************************************

  Winamp controller library

                      Copyright 1999 Gavin Smyth
                 http://www.beesknees.freeserve.co.uk

******************************************************************************/

#ifndef _h_winamp_manager_h_
#define _h_winamp_manager_h_

class WinampManager
{
public:
  WinampManager();
  ~WinampManager();

  // Step forward or back a small number of seconds
  bool Step( bool forward = true );

  // Skip forward or backward a track
  bool Skip( bool forward = true );

  // Bump the volumen up or down
  bool Volume( bool up );

  // Exit Winamp and shutdown Windows
  bool Exit();

  // Indicate that the Winamp window is known and does not need to
  // be searched for
  void SetWinamp( HWND hwnd ) { winampWindow = hwnd; }

private:
  // Send an arbitrary message to Winamp
  bool SendWinamp( UINT message, WPARAM wparam, LPARAM lparam );

  // Slightly specialised for to send a "button press" message
  bool SendButton( WPARAM button );

  // Cached Winamp window handle
  HWND winampWindow;

  // Disallow copying
  WinampManager( const WinampManager& );
  WinampManager& operator=( const WinampManager& );
};

#endif // _h_winamp_manager_h_
